<?php
/**
 * SellerForCreate
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi. BU. Продавцы
 *
 * Управление продавцами
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\BuClient\Dto;

use \ArrayAccess;
use \Ensi\BuClient\ObjectSerializer;

/**
 * SellerForCreate Class Doc Comment
 *
 * @category Class
 * @package  Ensi\BuClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class SellerForCreate implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'SellerForCreate';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'legal_name' => 'string',
        'external_id' => 'string',
        'inn' => 'string',
        'kpp' => 'string',
        'legal_address' => 'string',
        'fact_address' => 'string',
        'payment_account' => 'string',
        'bank' => 'string',
        'bank_address' => 'string',
        'bank_bik' => 'string',
        'status' => '\Ensi\BuClient\Dto\SellerStatusEnum',
        'manager_id' => 'int',
        'correspondent_account' => 'string',
        'storage_address' => 'string',
        'site' => 'string',
        'can_integration' => 'bool',
        'sale_info' => 'string',
        'city' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'legal_name' => null,
        'external_id' => null,
        'inn' => null,
        'kpp' => null,
        'legal_address' => null,
        'fact_address' => null,
        'payment_account' => null,
        'bank' => null,
        'bank_address' => null,
        'bank_bik' => null,
        'status' => null,
        'manager_id' => null,
        'correspondent_account' => null,
        'storage_address' => null,
        'site' => null,
        'can_integration' => null,
        'sale_info' => null,
        'city' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'legal_name' => false,
        'external_id' => false,
        'inn' => false,
        'kpp' => false,
        'legal_address' => false,
        'fact_address' => false,
        'payment_account' => false,
        'bank' => false,
        'bank_address' => false,
        'bank_bik' => false,
        'status' => false,
        'manager_id' => false,
        'correspondent_account' => false,
        'storage_address' => false,
        'site' => false,
        'can_integration' => false,
        'sale_info' => false,
        'city' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::$openAPINullables[$property])) {
            return self::$openAPINullables[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'legal_name' => 'legal_name',
        'external_id' => 'external_id',
        'inn' => 'inn',
        'kpp' => 'kpp',
        'legal_address' => 'legal_address',
        'fact_address' => 'fact_address',
        'payment_account' => 'payment_account',
        'bank' => 'bank',
        'bank_address' => 'bank_address',
        'bank_bik' => 'bank_bik',
        'status' => 'status',
        'manager_id' => 'manager_id',
        'correspondent_account' => 'correspondent_account',
        'storage_address' => 'storage_address',
        'site' => 'site',
        'can_integration' => 'can_integration',
        'sale_info' => 'sale_info',
        'city' => 'city'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'legal_name' => 'setLegalName',
        'external_id' => 'setExternalId',
        'inn' => 'setInn',
        'kpp' => 'setKpp',
        'legal_address' => 'setLegalAddress',
        'fact_address' => 'setFactAddress',
        'payment_account' => 'setPaymentAccount',
        'bank' => 'setBank',
        'bank_address' => 'setBankAddress',
        'bank_bik' => 'setBankBik',
        'status' => 'setStatus',
        'manager_id' => 'setManagerId',
        'correspondent_account' => 'setCorrespondentAccount',
        'storage_address' => 'setStorageAddress',
        'site' => 'setSite',
        'can_integration' => 'setCanIntegration',
        'sale_info' => 'setSaleInfo',
        'city' => 'setCity'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'legal_name' => 'getLegalName',
        'external_id' => 'getExternalId',
        'inn' => 'getInn',
        'kpp' => 'getKpp',
        'legal_address' => 'getLegalAddress',
        'fact_address' => 'getFactAddress',
        'payment_account' => 'getPaymentAccount',
        'bank' => 'getBank',
        'bank_address' => 'getBankAddress',
        'bank_bik' => 'getBankBik',
        'status' => 'getStatus',
        'manager_id' => 'getManagerId',
        'correspondent_account' => 'getCorrespondentAccount',
        'storage_address' => 'getStorageAddress',
        'site' => 'getSite',
        'can_integration' => 'getCanIntegration',
        'sale_info' => 'getSaleInfo',
        'city' => 'getCity'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('legal_name', $data, null);
        $this->setIfExists('external_id', $data, null);
        $this->setIfExists('inn', $data, null);
        $this->setIfExists('kpp', $data, null);
        $this->setIfExists('legal_address', $data, null);
        $this->setIfExists('fact_address', $data, null);
        $this->setIfExists('payment_account', $data, null);
        $this->setIfExists('bank', $data, null);
        $this->setIfExists('bank_address', $data, null);
        $this->setIfExists('bank_bik', $data, null);
        $this->setIfExists('status', $data, null);
        $this->setIfExists('manager_id', $data, null);
        $this->setIfExists('correspondent_account', $data, null);
        $this->setIfExists('storage_address', $data, null);
        $this->setIfExists('site', $data, null);
        $this->setIfExists('can_integration', $data, null);
        $this->setIfExists('sale_info', $data, null);
        $this->setIfExists('city', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets legal_name
     *
     * @return string|null
     */
    public function getLegalName()
    {
        return $this->container['legal_name'];
    }

    /**
     * Sets legal_name
     *
     * @param string|null $legal_name Юридическое наименование организации
     *
     * @return $this
     */
    public function setLegalName($legal_name)
    {


        /*if (is_null($legal_name)) {
            throw new \InvalidArgumentException('non-nullable legal_name cannot be null');
        }*/
        $this->container['legal_name'] = $legal_name;

        return $this;
    }

    /**
     * Gets external_id
     *
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->container['external_id'];
    }

    /**
     * Sets external_id
     *
     * @param string|null $external_id Внешний код
     *
     * @return $this
     */
    public function setExternalId($external_id)
    {


        /*if (is_null($external_id)) {
            throw new \InvalidArgumentException('non-nullable external_id cannot be null');
        }*/
        $this->container['external_id'] = $external_id;

        return $this;
    }

    /**
     * Gets inn
     *
     * @return string|null
     */
    public function getInn()
    {
        return $this->container['inn'];
    }

    /**
     * Sets inn
     *
     * @param string|null $inn ИНН
     *
     * @return $this
     */
    public function setInn($inn)
    {


        /*if (is_null($inn)) {
            throw new \InvalidArgumentException('non-nullable inn cannot be null');
        }*/
        $this->container['inn'] = $inn;

        return $this;
    }

    /**
     * Gets kpp
     *
     * @return string|null
     */
    public function getKpp()
    {
        return $this->container['kpp'];
    }

    /**
     * Sets kpp
     *
     * @param string|null $kpp КПП
     *
     * @return $this
     */
    public function setKpp($kpp)
    {


        /*if (is_null($kpp)) {
            throw new \InvalidArgumentException('non-nullable kpp cannot be null');
        }*/
        $this->container['kpp'] = $kpp;

        return $this;
    }

    /**
     * Gets legal_address
     *
     * @return string|null
     */
    public function getLegalAddress()
    {
        return $this->container['legal_address'];
    }

    /**
     * Sets legal_address
     *
     * @param string|null $legal_address Юр. адрес
     *
     * @return $this
     */
    public function setLegalAddress($legal_address)
    {


        /*if (is_null($legal_address)) {
            throw new \InvalidArgumentException('non-nullable legal_address cannot be null');
        }*/
        $this->container['legal_address'] = $legal_address;

        return $this;
    }

    /**
     * Gets fact_address
     *
     * @return string|null
     */
    public function getFactAddress()
    {
        return $this->container['fact_address'];
    }

    /**
     * Sets fact_address
     *
     * @param string|null $fact_address Фактический адрес
     *
     * @return $this
     */
    public function setFactAddress($fact_address)
    {


        /*if (is_null($fact_address)) {
            throw new \InvalidArgumentException('non-nullable fact_address cannot be null');
        }*/
        $this->container['fact_address'] = $fact_address;

        return $this;
    }

    /**
     * Gets payment_account
     *
     * @return string|null
     */
    public function getPaymentAccount()
    {
        return $this->container['payment_account'];
    }

    /**
     * Sets payment_account
     *
     * @param string|null $payment_account Номер банковского счета
     *
     * @return $this
     */
    public function setPaymentAccount($payment_account)
    {


        /*if (is_null($payment_account)) {
            throw new \InvalidArgumentException('non-nullable payment_account cannot be null');
        }*/
        $this->container['payment_account'] = $payment_account;

        return $this;
    }

    /**
     * Gets bank
     *
     * @return string|null
     */
    public function getBank()
    {
        return $this->container['bank'];
    }

    /**
     * Sets bank
     *
     * @param string|null $bank Наименование банка
     *
     * @return $this
     */
    public function setBank($bank)
    {


        /*if (is_null($bank)) {
            throw new \InvalidArgumentException('non-nullable bank cannot be null');
        }*/
        $this->container['bank'] = $bank;

        return $this;
    }

    /**
     * Gets bank_address
     *
     * @return string|null
     */
    public function getBankAddress()
    {
        return $this->container['bank_address'];
    }

    /**
     * Sets bank_address
     *
     * @param string|null $bank_address Юридический адрес банка
     *
     * @return $this
     */
    public function setBankAddress($bank_address)
    {


        /*if (is_null($bank_address)) {
            throw new \InvalidArgumentException('non-nullable bank_address cannot be null');
        }*/
        $this->container['bank_address'] = $bank_address;

        return $this;
    }

    /**
     * Gets bank_bik
     *
     * @return string|null
     */
    public function getBankBik()
    {
        return $this->container['bank_bik'];
    }

    /**
     * Sets bank_bik
     *
     * @param string|null $bank_bik БИК банка
     *
     * @return $this
     */
    public function setBankBik($bank_bik)
    {


        /*if (is_null($bank_bik)) {
            throw new \InvalidArgumentException('non-nullable bank_bik cannot be null');
        }*/
        $this->container['bank_bik'] = $bank_bik;

        return $this;
    }

    /**
     * Gets status
     *
     * @return \Ensi\BuClient\Dto\SellerStatusEnum|null
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param \Ensi\BuClient\Dto\SellerStatusEnum|null $status status
     *
     * @return $this
     */
    public function setStatus($status)
    {


        /*if (is_null($status)) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }*/
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets manager_id
     *
     * @return int|null
     */
    public function getManagerId()
    {
        return $this->container['manager_id'];
    }

    /**
     * Sets manager_id
     *
     * @param int|null $manager_id ID менеджера
     *
     * @return $this
     */
    public function setManagerId($manager_id)
    {


        /*if (is_null($manager_id)) {
            throw new \InvalidArgumentException('non-nullable manager_id cannot be null');
        }*/
        $this->container['manager_id'] = $manager_id;

        return $this;
    }

    /**
     * Gets correspondent_account
     *
     * @return string|null
     */
    public function getCorrespondentAccount()
    {
        return $this->container['correspondent_account'];
    }

    /**
     * Sets correspondent_account
     *
     * @param string|null $correspondent_account Номер корреспондентского счета банка
     *
     * @return $this
     */
    public function setCorrespondentAccount($correspondent_account)
    {


        /*if (is_null($correspondent_account)) {
            throw new \InvalidArgumentException('non-nullable correspondent_account cannot be null');
        }*/
        $this->container['correspondent_account'] = $correspondent_account;

        return $this;
    }

    /**
     * Gets storage_address
     *
     * @return string|null
     */
    public function getStorageAddress()
    {
        return $this->container['storage_address'];
    }

    /**
     * Sets storage_address
     *
     * @param string|null $storage_address Адреса складов отгрузки
     *
     * @return $this
     */
    public function setStorageAddress($storage_address)
    {


        /*if (is_null($storage_address)) {
            throw new \InvalidArgumentException('non-nullable storage_address cannot be null');
        }*/
        $this->container['storage_address'] = $storage_address;

        return $this;
    }

    /**
     * Gets site
     *
     * @return string|null
     */
    public function getSite()
    {
        return $this->container['site'];
    }

    /**
     * Sets site
     *
     * @param string|null $site Сайт компании
     *
     * @return $this
     */
    public function setSite($site)
    {


        /*if (is_null($site)) {
            throw new \InvalidArgumentException('non-nullable site cannot be null');
        }*/
        $this->container['site'] = $site;

        return $this;
    }

    /**
     * Gets can_integration
     *
     * @return bool|null
     */
    public function getCanIntegration()
    {
        return $this->container['can_integration'];
    }

    /**
     * Sets can_integration
     *
     * @param bool|null $can_integration Подтверждение о возможности работы с Платформой с использованием автоматических механизмов интеграции
     *
     * @return $this
     */
    public function setCanIntegration($can_integration)
    {


        /*if (is_null($can_integration)) {
            throw new \InvalidArgumentException('non-nullable can_integration cannot be null');
        }*/
        $this->container['can_integration'] = $can_integration;

        return $this;
    }

    /**
     * Gets sale_info
     *
     * @return string|null
     */
    public function getSaleInfo()
    {
        return $this->container['sale_info'];
    }

    /**
     * Sets sale_info
     *
     * @param string|null $sale_info Бренды и товары, которыми торгует Продавец
     *
     * @return $this
     */
    public function setSaleInfo($sale_info)
    {


        /*if (is_null($sale_info)) {
            throw new \InvalidArgumentException('non-nullable sale_info cannot be null');
        }*/
        $this->container['sale_info'] = $sale_info;

        return $this;
    }

    /**
     * Gets city
     *
     * @return string|null
     */
    public function getCity()
    {
        return $this->container['city'];
    }

    /**
     * Sets city
     *
     * @param string|null $city Город продавца
     *
     * @return $this
     */
    public function setCity($city)
    {


        /*if (is_null($city)) {
            throw new \InvalidArgumentException('non-nullable city cannot be null');
        }*/
        $this->container['city'] = $city;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


